<?php

require_once 'pingmk-var.php';

abstract class BasePING {
	
	//define constant value
	const BUTTON_DESIGN_NORMAL = 'Нормално';
	const BUTTON_DESIGN_COMPACT = 'Компактно';
	const Adresa = 'Adresa'; 
	const Naslov = 'Naslov';
	const Kopce = 'Kopce';
	const Tip = 'none';
	
    // define properties
    var $name; //name of the vote button
    var $baseURL; // vote button URL
    var $buttonDesign; //vote button design
    var $wp_options; // contains wordpress option value, in array
    
    var $finalURL; //final URL for display, after constructs
    
    var $option_append_type;
	var $option_button_design;
	var $option_button_weight;
	
	var $button_weight_value;
	var $normalButtonWH;
	var $compactButtonWH;
	
    /**
     * Construct the default value for digg digg 
     * @param $name name of the vote site
     * @param $baseURL URL for the vote button 
     */
    function BasePING($name, $baseURL) {
    	$this->name = $name;
    	$this->baseURL = $baseURL;
    	$this->initWPOptions();
    }
    
    /**
     * Construct the wordpress options value
     */
    private function initWPOptions() {
    	$this->wp_options = array();
    	$this->wp_options[$this->option_append_type] = self::Tip;
    	$this->wp_options[$this->option_button_design] = self::BUTTON_DESIGN_NORMAL;
    	$this->wp_options[$this->option_button_weight] = $this->button_weight_value;
    }
    
	/*
     * return the button order value
     */
    public function get_button_weight(){
    	return $this->wp_options[$this->option_button_weight];
    }
    
    /*
     * return the append type value
     */
    public function get_append_type(){
    	return $this->wp_options[$this->option_append_type];
    }
    
	/*
     * return the button design value
     */
    public function get_button_design(){
    	return $this->wp_options[$this->option_button_design];
    }
    
    /**
     * Return the button design layout 
     * @param $button button design, normal or compact
     * @return button design
     */
    public function getButtonDesign($button){
    	
    	$result ='';
    	
    	if($button==self::BUTTON_DESIGN_NORMAL){
    		$result = $this->normalButtonWH;
    	}else if ($button==self::BUTTON_DESIGN_COMPACT){
    		$result = $this->compactButtonWH;
    	}else{
    		$result = $this->normalButtonWH;
    	}
    	
    	return $result;
    }
	
    /**
     * @param $url post link
     * @param $title post title
     * @param $button button design
     * 
     */
    public function construstURL($url, $title,$button){
    	$result = '';
    	
    	$result = str_replace(self::Kopce,$this->getButtonDesign($button),$this->baseURL);
    	$result = str_replace(self::Naslov,$title,$result);
    	$result = str_replace(self::Adresa,$url,$result);
    	
    	$this->finalURL = $result;
    }
    
}

//stumbleupon.com properties and methods
class PING_Golemo extends BasePING{
	
	//constant value
	const NAME = "Ping.mk #1";
	const BASEURL = "<a href='http://r.ping.mk/submit?url=Adresa&amp;title=Naslov'>Kopce</a>";
	const Tip = "pingmk_golemo_appendType";
	const Kopce = "pingmk_golemo_buttonDesign";
	const OPTION_BUTTON_WEIGHT = "pingmk_golemo_button_weight";
	const DEFAULT_BUTTON_WEIGHT = "65";
	
	//constructor
    public function PING_Golemo() {
    	
    	$normalbutton = "<img src='" . PING_PLUGPATH . "image/pingmk.png' alt='Share @ Ping.mk' />";
		
    	//wordpress option value
		$this->option_append_type = self::Tip;
		$this->option_button_design = self::Kopce;
		$this->option_button_weight = self::OPTION_BUTTON_WEIGHT;
		$this->normalButtonWH = $normalbutton;
		$this->compactButtonWH = $normalbutton;
		$this->button_weight_value = self::DEFAULT_BUTTON_WEIGHT;
	
        parent::BasePING(self::NAME, self::BASEURL);
    }     
}


//delicious.com properties and methods
class PING_Malo extends BasePING{
	
	//constant value
	const NAME = "Ping.mk #2 (small)";
	const BASEURL = "<a href='http://r.ping.mk/submit?url=Adresa&amp;title=Naslov'>Kopce</a>";
	const Tip = "pingmk_malo_appendType";
	const Kopce = "pingmk_malo_buttonDesign";
	const OPTION_BUTTON_WEIGHT = "pingmk_malo_button_weight";
	const DEFAULT_BUTTON_WEIGHT = "60";
	

	//constructor
    public function PING_Malo() {
    	
    	$normalbutton = "<img src='" . PING_PLUGPATH . "image/pingmalo.png' alt='Share @ Ping.mk' />";
		
    	//wordpress option value
		$this->option_append_type = self::Tip;
		$this->option_button_design = self::Kopce;
		$this->option_button_weight = self::OPTION_BUTTON_WEIGHT;
		$this->normalButtonWH = $normalbutton;
		$this->compactButtonWH = $normalbutton;
		$this->button_weight_value = self::DEFAULT_BUTTON_WEIGHT;
	
        parent::BasePING(self::NAME, self::BASEURL);
    }     
}




?>